package dpl::tei;

use dpl;
use Data::Dumper;

$VERSION = 0.01;

sub mktei {
  my $file = shift;

  my $dic = dpl::opendb($file);
  open(LIST,"sort -d -f $file.wrdlst|") or die("cant open $file\n");

  print header();
  # TODO -- print front matter & stuff like

  print "<body>\n";

  while (<LIST>) {
    chomp;
    next if /^!/;
    print " <entry>\n";
    print entry($_,$dic->{h}{$_});
    print " </entry>\n";
  }

  print "</body>\n";

  # TODO -- print back matter...

  close LIST;
}

sub header {
  return <<'EOX';
<!DOCTYPE TEI.2 PUBLIC "-//TEI p3//DTD Main Document Type//EN"
                       "tei2.dtd" [
<!ENTITY % TEI.dictionaries 'INCLUDE' >
]>
EOX
}

sub entry {
  my ($term,$entry) = @_;
  print "  <form>\n";
  print "   <orth>$term</orth>\n";
  print "  </form>\n";

  foreach (@$entry) {
    print "  <hom>\n";
    print "   <def>$_->{sem}</def>\n" if exists($_->{sem});
    print "   <eg>$_->{!ex}</eg>\n" if exists($_->{!ex});
    print "   <usg type='syn'>",join("; ",@{$_->{syn}}),"</usg>\n" if exists($_->{syn});
    print "  </hom>\n";
  }

}

1;
__END__
